"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var image_source_1 = require("tns-core-modules/image-source");
// TODO View
function labelImage(options) {
    return new Promise(function (resolve, reject) {
        try {
            var firebaseVisionLabelDetector_1 = com.google.firebase.ml.vision.FirebaseVision.getInstance().getVisionLabelDetector();
            var onSuccessListener = new com.google.android.gms.tasks.OnSuccessListener({
                onSuccess: function (labels) {
                    var result = {
                        labels: []
                    };
                    for (var i = 0; i < labels.size(); i++) {
                        var label = labels.get(i);
                        result.labels.push({
                            text: label.getLabel(),
                            confidence: label.getConfidence()
                        });
                    }
                    resolve(result);
                    firebaseVisionLabelDetector_1.close();
                }
            });
            var onFailureListener = new com.google.android.gms.tasks.OnFailureListener({
                onFailure: function (exception) { return reject(exception.getMessage()); }
            });
            firebaseVisionLabelDetector_1
                .detectInImage(getImage(options))
                .addOnSuccessListener(onSuccessListener)
                .addOnFailureListener(onFailureListener);
        }
        catch (ex) {
            console.log("Error in firebase.mlkit.labelImage: " + ex);
            reject(ex);
        }
    });
}
exports.labelImage = labelImage;
// TODO move
function getImage(options) {
    var image = options.image instanceof image_source_1.ImageSource ? options.image.android : options.image.imageSource.android;
    return com.google.firebase.ml.vision.common.FirebaseVisionImage.fromBitmap(image);
}
